#define _CRT_SECURE_NO_WARNINGS
//
// Copyright (c) 2004 - InfoMus Lab - DIST - University of Genova
//
// InfoMus Lab (Laboratorio di Informatica Musicale)
// DIST - University of Genova
//
// http://www.infomus.dist.unige.it
// news://infomus.dist.unige.it
// mailto:staff@infomus.dist.unige.it
//
// Developer: Gualtiero Volpe
// mailto:volpe@infomus.dist.unige.it
//
// Developer: Trey Harrison
// mailto:trey@treyharrison.com
//
// Last modified: Oct. 26 2006
//

#include "FFGLPluginSDK.h"
#include <stdio.h>
#include <memory.h>
#include <algorithm>

// Buffer used by the default implementation of getParameterDisplay
static char s_DisplayValue[ 16 ];

////////////////////////////////////////////////////////
// CFreeFrameGLPlugin constructor and destructor
////////////////////////////////////////////////////////

CFreeFrameGLPlugin::CFreeFrameGLPlugin() :
	CFFGLPluginManager(),
	bpm( 120.0f ),
	barPhase( 0.0f )
{
}

CFreeFrameGLPlugin::~CFreeFrameGLPlugin()
{
}

////////////////////////////////////////////////////////
// Default implementation of CFreeFrameGLPlugin methods
////////////////////////////////////////////////////////

char* CFreeFrameGLPlugin::GetParameterDisplay( unsigned int index )
{
	FFParameterType pType = m_pPlugin->GetParamType( index );
	if( pType != FFParameterType::FF_FAIL )
	{
		if( pType == FFParameterType::FF_TYPE_TEXT )
		{
			return m_pPlugin->GetTextParameter( index );
		}
		else
		{
			std::string stringValue = std::to_string(m_pPlugin->GetFloatParameter( index ));
			memset(s_DisplayValue, 0, sizeof(s_DisplayValue));
			memcpy(s_DisplayValue, stringValue.c_str(), std::min(sizeof(s_DisplayValue), stringValue.length()));
			return s_DisplayValue;
		}
	}

	return nullptr;
}

FFResult CFreeFrameGLPlugin::SetFloatParameter( unsigned int index, float value )
{
	return FF_FAIL;
}

FFResult CFreeFrameGLPlugin::SetTextParameter( unsigned int index, const char* value )
{
	return FF_FAIL;
}

float CFreeFrameGLPlugin::GetFloatParameter( unsigned int index )
{
	return 0.0;
}

char* CFreeFrameGLPlugin::GetTextParameter( unsigned int index )
{
	return (char*)FF_FAIL;
}

FFInputStatus CFreeFrameGLPlugin::GetInputStatus( unsigned int index )
{
	if( index >= GetMaxInputs() )
		return FFInputStatus::FF_FAIL;

	return FFInputStatus::FF_INPUT_INUSE;
}

void CFreeFrameGLPlugin::SetBeatInfo( float bpm, float barPhase )
{
	this->bpm = bpm;
	this->barPhase = barPhase;
}

void CFreeFrameGLPlugin::SetHostInfo(const char * hostname, const char * version)
{
	hostInfos.name = hostname;
	hostInfos.version = version;
}

void CFreeFrameGLPlugin::SetSampleRate(unsigned int _sampleRate)
{
	sampleRate = _sampleRate;
}

